#! /usr/bin/env python

import Tkinter
from Tkinter import Tk, Canvas, Button
from xml.dom.minidom import parseString
from idlelib.TreeWidget import TreeItem, TreeNode
import os, sys, getopt

class Frame(Tkinter.Frame):

    def __init__(self, master=None):
        self.xmlfile = ""
        self.opt()
        Tkinter.Frame.__init__(self,master)
        self.master.geometry('+20+20')
        self.canvas = Tkinter.Canvas(self, width =300, height = 500, bg='white' )
        self.canvas.pack(fill='both', expand=1)

        confile = self.xmlfile
        text = open(confile).read()
        dom = parseString(text)
        item = DomTreeItem(dom.documentElement)
        node = TreeNode(self.canvas, None, item)
        node.update()
        node.expand()

        q = Tkinter.Button(self, text="Close",  fg='Blue',  command=self.quit)
        q.pack()

    def usage(self):
        usage_message = """\
Usage: dom_tree.py [-h] [-f]
-h: Print usage and exit
-f: Configuration file name
"""
        sys.stderr.write(usage_message)
   
    def opt(self):
       try:
         opts, args = getopt.getopt(sys.argv[1:], "f:h")
       except getopt.GetoptError:
         sys.stdout = sys.stderr
         self.usage();
         sys.exit(1)
        
       self.xmlfile = ""
       for o, a in opts:
         if o == "-h":
           self.usage();
           sys.exit(1)
         if o == "-f":
           self.xmlfile = a
             
       if self.xmlfile == "":
         self.usage()
         sys.exit(1)

    def close(self):
        self.master.destroy()
    
class DomTreeItem(TreeItem):
    def __init__(self, node):
        self.node = node

    def GetText(self):
        node = self.node
        if node.nodeType == node.ELEMENT_NODE:
            #print node.attributes.keys()
            return node.nodeName
        elif node.nodeType == node.TEXT_NODE:
            return node.nodeValue
        else:
            return node.nodeValue
    def IsExpandable(self):
        node = self.node
        return node.hasChildNodes()
    def GetSubList(self):
        parent = self.node
        children = parent.childNodes

        prelist = [DomTreeItem(node) for node in children]
        itemlist = [item for item in prelist if item.GetText().strip()]

        return itemlist

def quit():
    canvas.master.destroy()

if __name__ =='__main__':

    f = Frame()
    f.pack(fill='both', expand=1)
    f.mainloop()
        
