#! /usr/bin/env python
import Tkinter
from Tkinter import *
import tkMessageBox, os.path, string, getopt
import genconf

class App(Frame):
  def usage(self):
    usage_message = """\
Usage: mkconfig_gui.py [-h] [-n] [-o]
-h: Print usage and exit
-n: Number of CPU DAQs
-o: Output file name
"""
    sys.stderr.write(usage_message)
   
  def opt(self):
    try:
      opts, args = getopt.getopt(sys.argv[1:], "n:o:h")
    except getopt.GetoptError:
      sys.stdout = sys.stderr

    self.daqno = 0
    self.ofile = ""
    for o, a in opts:
      if o == "-h":
        self.usage();
        sys.exit(1)
      if o == "-n":
        self.daqno = int(a)
      if o == "-o":
        self.ofile = a
    if(self.daqno <= 0):
      self.usage()
      sys.exit(1)
    if(self.ofile == ""):
      print "No output file name was specified"
      self.ofile = "config.xml.generated"

    self.g  = { }
    self.usegate = StringVar()
    
    self.l  = []
      
    self.l0 = []
    self.e0 = []
    self.l1 = []
    self.e1 = []
    self.l2 = []
    self.e2 = []
    #self.l3 = []
    #self.e3 = []            
    self.l4 = []
    self.e4 = []

    ldaqnums = []
    ldaqnums.append('not use')
    for i in range(self.daqno):
      si = str(i)
      ldaqnums.append(si)

    self.daqnums = tuple(ldaqnums)
    #print self.daqnums
    
  def daqunit(self, index):
    t = " -----------------   DAQ #" + str(index) + '   ----------------- '
    self.l.append( Label(self, text = t, fg='Blue') )

    #self.g[index] = Radiobutton(self, text='Use GATENET @DAQ#' +str(index), variable=self.usegate, value=str(index) ) 


    self.l0.append( Label(self, text = "  DAQ Group name (e.g. mygroup0) :") )
    self.e0.append(Entry(self, width=20))

    self.l1.append( Label(self, text = "  CPU DAQ IP addr.(e.g. 192.168.1.2):") )
    self.e1.append(Entry(self, width=20))

    self.l2.append( Label(self, text = "  NEUNETs addr. (e.g. 16, 18-20, 22):") )
    self.e2.append(Entry(self, width=20))

    #self.l3.append( Label(self, text = "  Maximum file size:") )
    #self.e3.append(Entry(self, width=40))

    self.l4.append( Label(self, text = "  Directory of data logging (e.g. /tmp):") )
    self.e4.append(Entry(self, width=20))            

    self.l[index].grid( row = 2 + 8*index, column =0, sticky = 'ns')
    #self.g[index].grid( row = 3 + 8*index, column =0, sticky = 'ns')
    
    self.l0[index].grid(row = 3 + 8*index, column =0, sticky = 'ns')
    self.e0[index].grid(row = 3 + 8*index, column =1, sticky = 'ns')

    self.l1[index].grid(row = 4 + 8*index, column =0, sticky = 'ns')
    self.e1[index].grid(row = 4 + 8*index, column =1, sticky = 'ns')
    
    self.l2[index].grid(row = 5 + 8*index, column =0, sticky = 'ns')
    self.e2[index].grid(row = 5 + 8*index, column =1, sticky = 'ns')
      
    self.l4[index].grid(row = 6 + 8*index, column =0, sticky = 'ns')
    self.e4[index].grid(row = 6 + 8*index, column =1, sticky = 'ns')
    
    #self.g[index].grid( row = 7 + 8*index, column =0, sticky = 'ns')
    

#    self.g[index].grid( row = 2 + 7*index, column =1, sticky = 'ns')
    
#    self.l0[index].grid(row = 3 + 7*index, column =0, sticky = 'ns')
#    self.e0[index].grid(row = 3 + 7*index, column =1, sticky = 'ns')

#    self.l1[index].grid(row = 4 + 7*index, column =0, sticky = 'ns')
#    self.e1[index].grid(row = 4 + 7*index, column =1, sticky = 'ns')
    
#    self.l2[index].grid(row = 5 + 7*index, column =0, sticky = 'ns')
#    self.e2[index].grid(row = 5 + 7*index, column =1, sticky = 'ns')
      
#    self.l4[index].grid(row = 6 + 7*index, column =0, sticky = 'ns')
#    self.e4[index].grid(row = 6 + 7*index, column =1, sticky = 'ns')

    #self.l3[index].grid(row = 7 + 7*index, column =0, sticky = 'ns')
    #self.e3[index].grid(row = 7 + 7*index, column =1, sticky = 'ns')
    
  def init(self):
    self.master.title("")

    f = Frame()
    a = Label(self, text=" Instrument ID  (e.g.  AAA): ", fg='Brown')
    self.inst  = Entry(self, width=24)

    o = Label(self, text="Operator addr. (e.g.192.168.1.1): ", fg='Brown')
    self.daqop = Entry(self, width=24)    
    
    b = Button(f, text="Create",fg='Blue', command=self.create)
    c = Button(f, text="Quit",  fg='Red',  command=self.quit)

    sl = Label( f, text="Use GATENET at DAQ# ", fg='Blue')
    self.s = Spinbox(f, values=self.daqnums)

    a.grid(row = 0, column =0, columnspan=1)
    self.inst.grid(row = 0, column =1, sticky = 'w')

    o.grid(row = 1, column =0, columnspan=1)
    self.daqop.grid(row = 1, column =1, sticky = 'w')

    lcol = 0
    for i in xrange(self.daqno):
      self.daqunit(i)

    sl.grid(row = lcol+1, column = 0)
    self.s.grid( row = lcol+1, column = 1)    

    b.grid(row = lcol+2, column = 0)
    c.grid(row = lcol+2, column = 1, sticky='e')
    #c.grid(row = lcol+1, column =1, sticky='w')
    #g.grid(row = lcol+2, column =1, sticky='e')

    f.pack(side=TOP, anchor=E, pady=5)

  def quit(self):
    self.master.destroy()
    
  def create(self):
    #outf = open('config.xml', 'w')
    outf = open(self.ofile, 'w')    
    sampling = '10'

    outf.write( genconf.make_root_begin() )
    outf.write( genconf.make_daqoperator( self.daqop.get() ) )
    outf.write( genconf.make_daq_groups_begin() )

    for daqId in xrange(self.daqno):

      neunets = genconf.neunetList(daqId, self.e2[daqId].get() )
                                   
      outf.write( genconf.make_daq_group_begin(daqId) )
      outf.write( genconf.make_daq_components_begin() )

      ord = 4*daqId
      outf.write( genconf.make_gatherer(  self.e1[daqId].get(), 4+ord, neunets, int(daqId)) )
      #outf.write( genconf.make_dispatcher(self.e1[daqId].get(), 3+ord, self.e3[daqId].get(), sampling) )
      outf.write( genconf.make_dispatcher(self.e1[daqId].get(), 3+ord, '', sampling) )      
      #outf.write( genconf.make_logger( self.e1[daqId].get(), 1+ord, neunets, int(daqId), self.e3[daqId].get(), self.e4[daqId].get(), self.inst.get() ) )
      outf.write( genconf.make_logger( self.e1[daqId].get(), 1+ord, neunets, int(daqId), '', self.e4[daqId].get(), self.inst.get() ) )
      outf.write( genconf.make_monitor(   self.e1[daqId].get(), 2+ord, neunets, int(daqId), sampling) )

      spin = self.s.get()
      if spin != 'not use' and spin == str(daqId):
      #if self.usegate.get() == str(daqId):
        print 'Use GATENET at DAQ#' + str(daqId)
        outf.write( genconf.make_gatenet(self.e1[daqId].get(), 4*(self.daqno - 1)+5) )
        
      outf.write( genconf.make_daq_components_end() )
      outf.write( genconf.make_daq_group_end() )
        
    outf.write( genconf.make_daq_groups_end() )
    outf.write( genconf.make_root_end() )

    outf.close()

    print self.ofile + ' was generated.'
    mycommand = 'python ./dom_tree.py -f ' + self.ofile
    os.system(mycommand)

  def __init__(self, master=None):
    Frame.__init__(self, master)
    self.opt()
    self.pack()
    self.init()

if __name__ == "__main__":

  app = App(); app.mainloop()
