#!/usr/bin/env python

# python documentation should be here (not yet)

# This program set data gereration rate on the NEUNET emulator.
# To set data rate, we have to connect TCP first then set
# the register using UDP.

import socket, struct, sys

arg_len = len(sys.argv)
if arg_len < 3:
	print "Usage: set_speed.py speed ip_address [ip_address ...]"
	print "use speed value 76 for 20kcps"
	sys.exit(1)

tcp_port       = 23
udp_port       = 4660
speed_address  = 0x1ad
speed_reg_len  = 1
bcp_header_len = 8
WRITE          = 0x80
READ           = 0xc0
speed          = sys.argv[1]

for ip_address in sys.argv[2:]:
	# need trailing comma not to print newline
	print 'trying to set speed', speed, 'to', ip_address, '...',

	t = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	u = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)

	# TCP connect (connect only.  don't read any data or write data)
	t.connect((ip_address, tcp_port))

	seq_num   = 1
	send_data = struct.pack('>BBBBIB', 0xff, WRITE, seq_num,
					speed_reg_len, speed_address, int(speed))
	u.sendto(send_data, (ip_address, udp_port))
	ack_packet = u.recvfrom(128) # ack packet

	# We have to read again to verify whether we can set the value
	seq_num   = 2
	send_data = struct.pack('>BBBBI', 0xff, READ, seq_num,
					speed_reg_len, speed_address)
	u.sendto(send_data, (ip_address, udp_port))
	reply_packet = u.recvfrom(bcp_header_len + speed_reg_len)
	# u.recvfrom()[0]: data
	# u.recvfrom()[1]: (host, address) tuple
	reply_speed  = struct.unpack('>BBBBIB', reply_packet[0])[-1]
	if int(speed) != int(reply_speed):
		print "fail!"
	else:
		print "done"

	t.close()
